<?php
/*
  $Id: asjpayment.php,v 1.0.1 2020/02/13
  catalog/includes/modules/payment/asjpayment.php
  http://www.asjpayment.jp/

  Copyright ASJ INC.

  Released under the version 2.0 of GNU General Public License
*/

	class asjpayment {
		var $code, $title, $description, $enabled;

// class constructor
	function asjpayment() {
		global $order;

		$this->code = 'asjpayment';
		$this->title = MODULE_PAYMENT_ASJPAYMENT_TEXT_TITLE;
		$this->description = MODULE_PAYMENT_ASJPAYMENT_TEXT_DESCRIPTION;
		$this->explain = MODULE_PAYMENT_ASJPAYMENT_TEXT_EXPLAIN;
		$this->sort_order = MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER;
		$this->enabled = ((MODULE_PAYMENT_ASJPAYMENT_STATUS == 'True') ? true : false);

		if((int)MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID > 0) {
			$this->order_status = MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID;
		}
		if(is_object($order)) $this->update_status();
			$this->form_action_url = MODULE_PAYMENT_ASJPAYMENT_URL;
			$this->email_footer = MODULE_PAYMENT_ASJPAYMENT_TEXT_EMAIL_FOOTER;//Add Japanese osCommerce
		}

// class methods
	function update_status() {
		global $order;

		if(($this->enabled == true) && ((int)MODULE_PAYMENT_ASJPAYMENT_ZONE > 0)) {
			$check_flag = false;
			$check_query = tep_db_query("select zone_id from " . TABLE_ZONES_TO_GEO_ZONES . " where geo_zone_id = '" . MODULE_PAYMENT_ASJPAYMENT_ZONE . "' and zone_country_id = '" . $order->billing['country']['id'] . "' order by zone_id");
			while ($check = tep_db_fetch_array($check_query)) {
				if($check['zone_id'] < 1) {
					$check_flag = true;
					break;
				} elseif ($check['zone_id'] == $order->billing['zone_id']) {
					$check_flag = true;
					break;
				}
			}
			if($check_flag == false) {
				$this->enabled = false;
			}
		}
	}

	function javascript_validation() {
		return false;
	}

	function selection() {
		global $order;

		for($i=1; $i<13; $i++) {
			$expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
		}
		$today = getdate(); 
		for($i=$today['year']; $i < $today['year']+10; $i++) {
			$expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
		}
		$selection = array('id' => $this->code,
							'module' => $this->title,
							'fields' => array('title' => $this->explain,'field' => '')
					);
		return $selection;
	}

	function pre_confirmation_check() {
		global $HTTP_POST_VARS;
		// Chrome̽
		$useragent = $_SERVER['HTTP_USER_AGENT'];
		if(strpos($useragent, 'Chrome/') !== false && strpos($useragent, 'Edge/') === false) {
			// å󥯥åߤ֤뤫ɤ
			$cookieopt = session_get_cookie_params();
			$re_cookie = true;
			if(strtolower($cookieopt['samesite']) === 'none' && $cookieopt['secure'] === true) {
				$re_cookie = false;
			}
			// å󤬥åȤȯԤƤʤ饻åѹƺƳ
			if($re_cookie === true && array_key_exists(session_name(), $_COOKIE)) {
				session_write_close();
				session_set_cookie_params($cookieopt["lifetime"], $cookieopt["path"]."; SameSite=None", $cookieopt["domain"], true, $cookieopt["httponly"]);
				session_start();
			}
		}
		return false;
	}

	function confirmation() {
		global $HTTP_POST_VARS, $order;

		$confirmation = array('title' => $this->title ,
							'fields' => array('title' => MODULE_PAYMENT_ASJPAYMENT_TEXT_CREDIT_METHOD)
						);
		return $confirmation;
	}

	function process_button() {
		global $HTTP_SERVER_VARS, $HTTP_POST_VARS,$currencies,$customer_id, $order, $asjpayment_order_id,$comments;

		$asjpayment_job_code = MODULE_PAYMENT_ASJPAYMENT_JOB_CODE;
		$asjpayment_admin_no = MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO;
		$mail = mb_convert_kana($order->customer['email_address'],"a");
		$asjpayment_charge_no = 0;
		tep_db_query("insert into asjpayment_charge(n_admin, n_amount, c_mail, d_create) values('$asjpayment_admin_no', '$total', '$mail' ,now())");
		$asjpayment_charge_no = tep_db_insert_id();
		$total = ceil($order->info['total']);
		$process_button_string = tep_draw_hidden_field('admin', MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO) .
								tep_draw_hidden_field('amount', $total) .
								tep_draw_hidden_field('charge', $asjpayment_charge_no) .
								tep_draw_hidden_field('mail', $mail);
		return $process_button_string;
	}

	function before_process() {
		global $order,$sales_id,$tranid,$refapproved,$refforwarded,$errcode,$errinfo,$errlevel,$r_code,$rec_type,$x_amount,$x_tax,$x_total,$asjpayment_cc_job_code;
	}

	function after_process() {
		global $insert_id,$sales_id,$tranid,$refapproved,$refforwarded,$errcode,$errinfo,$errlevel,$r_code,$rec_type,$x_amount,$x_tax,$x_total, $order,$asjpayment_cc_job_code,$comments;

		if(strlen($comments) > 0 ) {
			$newline = "\n\n";
		} else {
			$newline = "";
		}
		$charge_no = $_POST['charge'];
		$comments .= $newline . "ɼֹ桧" . $charge_no;
		tep_db_query("update " . TABLE_ORDERS_STATUS_HISTORY . " set comments='$comments' where orders_id='$insert_id'");
	}

	function output_error() {
		return false;
	}

	function get_error() {
		global $HTTP_POST_VARS,$HTTP_GET_VARS;

		if(isset($HTTP_GET_VARS['error']) && (strlen($HTTP_GET_VARS['error']) > 0)) {
			$error_message = stripslashes(urldecode($HTTP_GET_VARS['error']));
		} else {
			$error_message = MODULE_PAYMENT_ASJPAYMENT_TEXT_ERROR_MESSAGE;
		}
		return array('title' => MODULE_PAYMENT_ASJPAYMENT_TEXT_ERROR,
					'error' => $error_message);
	}

	function check() {
		if(!isset($this->_check)) {
			$check_query = tep_db_query("select configuration_value from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ASJPAYMENT_STATUS'");
			$this->_check = tep_db_num_rows($check_query);
		}
	 	return $this->_check;
	}

	function install() {
		tep_db_query("create table if not exists asjpayment_charge(n_charge int auto_increment primary key, n_admin int, n_amount int, c_mail varchar(96), d_create datetime)");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('ASJڥȤλ', 'MODULE_PAYMENT_ASJPAYMENT_STATUS', 'True', 'ASJڥȥ쥸åȥɷѤͭˤޤ?', '6', '0', 'tep_cfg_select_option(array(\'True\', \'False\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ASJڥ Url', 'MODULE_PAYMENT_ASJPAYMENT_URL', 'https://www.asjpayment.jp/cgi-bin/ps_payment.cgi', 'ѾURL', '6', '0', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ֹ', 'MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO', '', 'ASJڥȷֹϤƤ', '6', '0', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Job Code', 'MODULE_PAYMENT_ASJPAYMENT_JOB_CODE', 'AUTH', '֥', '6', '0', 'tep_cfg_select_option(array(\'CHECK\', \'CAPTURE\', \'AUTH\', \'SAUTH\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('', 'MODULE_PAYMENT_ASJPAYMENT_RET', 'OFF', 'ΤԤ򤷤Ƥ', '6', '5', 'tep_cfg_select_option(array(\'ON\', \'OFF\'), ', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('ɽν', 'MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER', '0', 'ɽν֤ꤷޤͽɽޤ', '6', '0', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Payment Zone', 'MODULE_PAYMENT_ASJPAYMENT_ZONE', '0', 'If a zone is selected, only enable this payment method for that zone.', '6', '2', 'tep_get_zone_class_title', 'tep_cfg_pull_down_zone_classes(', now())");
		tep_db_query("insert into " . TABLE_CONFIGURATION . " (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, use_function, date_added) values ('ơ', 'MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID', '0', '쥸åȥɷΥơꤷƤ', '6', '0', 'tep_cfg_pull_down_order_statuses(', 'tep_get_order_status_name', now())");
	}

	function remove() {
		tep_db_query("delete from " . TABLE_CONFIGURATION . " where configuration_key = 'MODULE_PAYMENT_ASJPAYMENT_STATUS'");
	}

	function keys() {
		return array('MODULE_PAYMENT_ASJPAYMENT_URL', 'MODULE_PAYMENT_ASJPAYMENT_ADMIN_NO',  'MODULE_PAYMENT_ASJPAYMENT_ORDER_STATUS_ID', 'MODULE_PAYMENT_ASJPAYMENT_SORT_ORDER');
	}
}
?>
